#include "goalsettings.h"
#include <QDebug>
GoalSettings::GoalSettings(QWidget *parent):QDialog (parent)
{

    labVal = new QLabel("goal profit:");
    sbValue = new QSpinBox(this);
    sbValue->setRange(-100000, 100000);

    chDel = new QCheckBox("remove goal");
    chDel->setChecked(false);

    QVBoxLayout* lSBVal = new QVBoxLayout;
    lSBVal->addWidget(labVal);
    lSBVal->addStretch();
    lSBVal->addWidget(sbValue);

    lSBOpt = new QVBoxLayout;
    lSBOpt->addItem(lSBVal);
    lSBOpt->addStretch();
    lSBOpt->addWidget(chDel);


    btnOk = new QPushButton(tr("&OK"),this);
    btnOk->setShortcut(QKeySequence("ENTER"));
    btnOk->setStatusTip(tr("Confirms the settings."));

    btnCancel = new QPushButton(tr("&Cancel"),this);
    btnCancel->setShortcut(QKeySequence("ESCAPE"));
    btnCancel->setStatusTip(tr("Closes the settings."));

    lButtons = new QHBoxLayout;
    lButtons->addStretch();
    lButtons->addWidget(btnOk);
    lButtons->addWidget(btnCancel);

    lMain = new QVBoxLayout;
    lMain->addLayout(lSBOpt);
    lMain->addLayout(lButtons);

    setLayout(lMain);

    connect(btnOk, SIGNAL(clicked(bool)), this, SLOT(accept()));
    connect(btnCancel, SIGNAL(clicked(bool)), this, SLOT(close()));


}
