#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "strategist.h"
#include <QMainWindow>
#include <QToolBar>
#include <QMenuBar>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include "mapview.h"


class MainWindow : public QMainWindow
{
    Q_OBJECT

    QToolBar* toolBar;

    QAction* actViewArr, *actViewVal, *actSetBarrier, *actSetGoal;
    QMenu* menuFile, *menuSet, *menuRun, *menuView;

    QVBoxLayout* lMain;

    MapView* mv;

    Map mainMap, resMap;

    Map* showedMap;

    Strategist strat;

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void showMap(Map *map);
    void initValues();

public slots:
    void newMap();
    void loadFile();
    void planStrategy();
    void showSettings();
    void saveSettings();
    void valToggled(bool checked);
    void arrToggled(bool checked);
    void barrToggled(bool checked);
    void goalToggled(bool checked);
    void setFieldProperty(int i, int j);
};

#endif // MAINWINDOW_H
