#include "setnewmap.h"

SetNewMap::SetNewMap(QWidget *parent) : QDialog(parent)
{

    labRows = new QLabel("rows:");
    sbRows = new QSpinBox(this);
    sbRows->setRange(0,50);

    lRows = new QHBoxLayout;
    lRows->addWidget(labRows);
    lRows->addWidget(sbRows);

    labCols = new QLabel("cols:");
    sbCols = new QSpinBox(this);
    sbCols->setRange(0,50);

    lCols = new QHBoxLayout;
    lCols->addWidget(labCols);
    lCols->addWidget(sbCols);

    btnOk = new QPushButton(tr("&OK"),this);
    btnOk->setShortcut(QKeySequence("ENTER"));
    btnOk->setStatusTip(tr("Confirms the settings."));

    btnCancel = new QPushButton(tr("&Cancel"),this);
    btnCancel->setShortcut(QKeySequence("ESCAPE"));
    btnCancel->setStatusTip(tr("Closes the settings."));

    lButtons = new QHBoxLayout;
    lButtons->addStretch();
    lButtons->addWidget(btnOk);
    lButtons->addWidget(btnCancel);

    lMain = new QVBoxLayout;
    lMain->addLayout(lRows);
    lMain->addLayout(lCols);
    lMain->addLayout(lButtons);

    setLayout(lMain);

    connect(btnOk, SIGNAL(clicked(bool)), this, SLOT(accept()));
    connect(btnCancel, SIGNAL(clicked(bool)), this, SLOT(close()));
}

int SetNewMap::getNumberOfRows()
{
    return sbRows->value();
}

void SetNewMap::setNumberOfRows(int rows)
{
    sbRows->setValue(rows);
}



int SetNewMap::getNumberOfCols()
{
    return sbCols->value();
}

void SetNewMap::setNumberOfCols(int cols)
{
    sbCols->setValue(cols);
}

