#include "settings.h"

Settings::Settings(QWidget *parent) : QDialog(parent)
{
    labPStr = new QLabel("probability to go straight:");
    sbPStraight = new QSpinBox(this);
    sbPStraight->setRange(0, 100);
    sbPStraight->setSingleStep(1);
    sbPStraight->setSuffix("%");
    sbPStraight->setValue(100);

    labPR = new QLabel("probability to turn right:");
    sbPRight = new QSpinBox(this);
    sbPRight->setRange(0, 100);
    sbPRight->setSingleStep(1);
    sbPRight->setSuffix("%");

    labPL = new QLabel("probability to turn left:");
    sbPLeft = new QSpinBox(this);
    sbPLeft->setRange(0, 100);
    sbPLeft->setSingleStep(1);
    sbPLeft->setSuffix("%");


    labPB = new QLabel("probability to turn back:");
    sbPBack = new QSpinBox(this);
    sbPBack->setRange(0, 100);
    sbPBack->setSingleStep(1);
    sbPBack->setSuffix("%");


    labCost = new QLabel("step costs:");
    sbCost = new QSpinBox(this);
    sbCost->setRange(-1000, 1000);


    labGamma = new QLabel("Gamma factor:");
    sbGamma = new QDoubleSpinBox(this);
    sbGamma->setRange(0.0, 1.0);
    sbGamma->setSingleStep(0.01);


    labMaxN = new QLabel("maximal number of iterations:");
    sbMaxN = new QSpinBox(this);
    sbMaxN->setRange(0, 1000);


    lSBDir = new QVBoxLayout;
    lSBDir->addWidget(labPStr);
    lSBDir->addWidget(sbPStraight);
    lSBDir->addWidget(labPR);
    lSBDir->addWidget(sbPRight);
    lSBDir->addWidget(labPL);
    lSBDir->addWidget(sbPLeft);
    lSBDir->addWidget(labPB);
    lSBDir->addWidget(sbPBack);
    lSBVal = new QVBoxLayout;
    lSBVal->addWidget(labCost);
    lSBVal->addWidget(sbCost);
    lSBVal->addWidget(labGamma);
    lSBVal->addWidget(sbGamma);
    lSBVal->addWidget(labMaxN);
    lSBVal->addWidget(sbMaxN);

    lSB = new QHBoxLayout;
    lSB->addLayout(lSBDir);
    lSB->addStretch();
    lSB->addLayout(lSBVal);


    btnOk = new QPushButton(tr("&OK"),this);
    btnOk->setShortcut(QKeySequence("ENTER"));
    btnOk->setStatusTip(tr("Confirms the settings."));

    btnCancel = new QPushButton(tr("&Cancel"),this);
    btnCancel->setShortcut(QKeySequence("ESCAPE"));
    btnCancel->setStatusTip(tr("Closes the settings."));

    lButtons = new QHBoxLayout;
    lButtons->addStretch();
    lButtons->addWidget(btnOk);
    lButtons->addWidget(btnCancel);

    lMain = new QVBoxLayout;
    lMain->addLayout(lSB);
    lMain->addLayout(lButtons);

    setLayout(lMain);

    connect(btnOk, SIGNAL(clicked(bool)), this, SLOT(accept()));
    connect(btnCancel, SIGNAL(clicked(bool)), this, SLOT(close()));

}
