#ifndef SETTINGS_H
#define SETTINGS_H

#include <QWidget>
#include <QDialog>
#include "define.h"
#include <QLabel>
#include <QSpinBox>
#include <QDoubleSpinBox>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QPushButton>
class Settings : public QDialog
{
    Q_OBJECT


    // parameters
    QSpinBox* sbPStraight;
    QSpinBox* sbPRight;
    QSpinBox* sbPLeft;
    QSpinBox* sbPBack;
    QDoubleSpinBox* sbGamma;
    QSpinBox* sbCost;
    QSpinBox* sbMaxN;


    QLabel* labPStr, *labPR,* labPL, *labPB, *labGamma, *labCost, *labMaxN;

    QPushButton *btnOk, *btnCancel;

    QHBoxLayout* lButtons, *lSB;
    QVBoxLayout* lMain, *lSBVal,* lSBDir;

public:
    explicit Settings(QWidget *parent = nullptr);

    double getPStraight(){return 0.01 * sbPStraight->value();}

    double getPRight(){return 0.01 * sbPRight->value();}

    double getPLeft(){return 0.01 * sbPLeft->value();}

    double getPBack(){return 0.01 * sbPBack->value();}

    double getGamma(){return sbGamma->value();}

    double getCost(){return double(sbCost->value());}

    int getMaxN(){return sbMaxN->value();}

    void setPStraight(double p){sbPStraight->setValue(int(100 * p));}

    void setPRight(double p){sbPRight->setValue(int(100 * p));}

    void setPLeft(double p){sbPLeft->setValue(int(100 * p));}

    void setPBack(double p){sbPBack->setValue(int(100 * p));}

    void setGamma(double p){sbGamma->setValue(p);}

    void setCost(double p){sbCost->setValue(int(p));}

    void setMaxN(int n){sbMaxN->setValue(n);}


signals:

public slots:
};

#endif // SETTINGS_H
