#include "strategist.h"
#include <math.h>
#include <iostream>
#include <string>
#include <sstream>
#include <fstream>
Strategist::Strategist()
{

}

Strategist::Strategist(const char *fileName)
{
    loadFromFile(fileName);
}

number Strategist::goNorth(Map& map, int r, int c)
{
    number res = getStepCost();
    if (r > 0 && map.at(r-1,c).getFlag() != Field::barier) {
        res += map.at(r-1,c).getValue() * getPOK();
    } else {
        res += map.at(r,c).getValue() * getPOK();
    }

    if (r + 1 < map.getRows() && map.at(r+1,c).getFlag() != Field::barier) {
        res += map.at(r+1,c).getValue() * getPBack();
    } else {
        res += map.at(r,c).getValue() * getPBack();
    }

    if (c > 0 && map.at(r,c - 1).getFlag() != Field::barier) {
        res += map.at(r,c - 1).getValue() * getPLeft();
    } else {
        res += map.at(r,c).getValue() * getPLeft();
    }

    if (c + 1 < map.getCols() && map.at(r,c + 1).getFlag() != Field::barier) {
        res += map.at(r,c + 1).getValue() * getPRight();
    } else {
        res += map.at(r,c).getValue() * getPRight();
    }

    return res * getGamma();
}





number Strategist::goWest(Map &map, int r, int c)
{
    number res = getStepCost();
    if (r > 0 && map.at(r-1,c).getFlag() != Field::barier) {
        res += map.at(r-1,c).getValue() * getPRight();
    } else {
        res += map.at(r,c).getValue() * getPRight();
    }

    if (r + 1 < map.getRows() && map.at(r+1,c).getFlag() != Field::barier) {
        res += map.at(r+1,c).getValue() * getPLeft();
    } else {
        res += map.at(r,c).getValue() * getPLeft();
    }

    if (c > 0 && map.at(r,c - 1).getFlag() != Field::barier) {
        res += map.at(r,c - 1).getValue() * getPOK();
    } else {
        res += map.at(r,c).getValue() * getPOK();
    }

    if (c + 1 < map.getCols() && map.at(r,c + 1).getFlag() != Field::barier) {
        res += map.at(r,c + 1).getValue() * getPBack();
    } else {
        res += map.at(r,c).getValue() * getPBack();
    }


    return res * getGamma();
}





number Strategist::goSouth(Map& map, int r, int c)
{
    number res = getStepCost();

    if (r > 0 && map.at(r-1,c).getFlag() != Field::barier) {
        res += map.at(r-1,c).getValue() * getPBack();
    } else {
        res += map.at(r,c).getValue() * getPBack();
    }

    if (r + 1 < map.getRows() && map.at(r+1,c).getFlag() != Field::barier) {
        res += map.at(r+1,c).getValue() * getPOK();
    } else {
        res += map.at(r,c).getValue() * getPOK();
    }

    if (c > 0 && map.at(r,c - 1).getFlag() != Field::barier) {
        res += map.at(r,c - 1).getValue() * getPRight();
    } else {
        res += map.at(r,c).getValue() * getPRight();
    }

    if (c + 1 < map.getCols() && map.at(r,c + 1).getFlag() != Field::barier) {
        res += map.at(r,c + 1).getValue() * getPLeft();
    } else {
        res += map.at(r,c).getValue() * getPLeft();
    }


    return res * getGamma();
}




number Strategist::goEast(Map &map, int r, int c)
{
    number res = getStepCost();

    if (r > 0 && map.at(r-1,c).getFlag() != Field::barier) {
        res += map.at(r-1,c).getValue() * getPLeft();
    } else {
        res += map.at(r,c).getValue() * getPLeft();
    }

    if (r + 1 < map.getRows() && map.at(r+1,c).getFlag() != Field::barier) {
        res += map.at(r+1,c).getValue() * getPRight();
    } else {
        res += map.at(r,c).getValue() * getPRight();
    }

    if (c > 0 && map.at(r,c - 1).getFlag() != Field::barier) {
        res += map.at(r,c - 1).getValue() * getPBack();
    } else {
        res += map.at(r,c).getValue() * getPBack();
    }

    if (c + 1 < map.getCols() && map.at(r,c + 1).getFlag() != Field::barier) {
        res += map.at(r,c + 1).getValue() * getPOK();
    } else {
        res += map.at(r,c).getValue() * getPOK();
    }

    return res * getGamma();
}







Strategist::choise Strategist::bestChoise(Map &map, int r, int c)
{

    number gn = goNorth(map, r, c);
    number gw = goWest(map, r, c);
    number gs = goSouth(map, r, c);
    number ge = goEast(map, r, c);

    choise bestChoise;
    bestChoise.value = gn;
    bestChoise.direction = Field::north;

    if (bestChoise.value < gw) {
        bestChoise.direction = Field::west;
        bestChoise.value = gw;
    }

    if (bestChoise.value < gs) {
        bestChoise.direction = Field::south;
        bestChoise.value = gs;
    }

    if (bestChoise.value < ge) {
        bestChoise.direction = Field::east;
        bestChoise.value = ge;
    }


    return bestChoise;

}




void Strategist::findGoal(Map &map, int &r, int &c)
{
    for (int i = 0; i < map.getRows(); i++) {
        for (int j = 0;j < map.getCols(); j++) {
            if (map.at(i,j).getFlag() == Field::goal && map.at(i,j).getValue() > 0){
                r = i;
                c = j;
                return;
            }
        }
    }
    std::cerr << "goal not found";
}









Map Strategist::plan(Map &map)
{
    Map cMap(map);
    Map tmpMap(map);
    cMap.printValues(std::cout);
    tmpMap.printValues(std::cout);


    bool changed = true;
    int n = 0;
    while (changed && n < getNMax()) {
        changed = false;

        for (int i = 0; i < cMap.getRows(); i++) {

            for (int j = 0; j < cMap.getCols(); j++) {

                if (cMap.at(i,j).getFlag() == Field::free){

                    choise bChoise = bestChoise(cMap, i, j);

                    if (fabs(tmpMap.at(i,j).getValue() - bChoise.value) >= 1e-3){

                        changed = true;

                        tmpMap.at(i,j).setValue(bChoise.value);
                        tmpMap.at(i,j).setbestChoise(bChoise.direction);

                    }

                }
            }
        }
        cMap.copy(tmpMap);
        n++;
    }

    DBG(n);
    tmpMap.printValues(std::cout);

    return tmpMap;
}





void Strategist::loadFromFile(const char *fileName)
{
    std::ifstream ifst(fileName);

    loadFromFile(ifst);

    ifst.close();
}


void Strategist::loadFromFile(std::istream &ist)
{
    std::string line;

    int mode = 0;

    while (getline(ist, line)) {
        if (line[0] == '#'){
            continue;
        }

        if (mode == 0) {
            if (line.find("straight") != line.npos) {
                std::stringstream ss(line);
                ss.ignore(50, ' ');

                number p;

                ss >> p;

                setPOK(p);

            } else if (line.find("right") != line.npos) {

                std::stringstream ss(line);
                ss.ignore(50, ' ');

                number p;

                ss >> p;

                setPRight(p);

            } else if (line.find("left") != line.npos) {

                std::stringstream ss(line);
                ss.ignore(50, ' ');

                number p;

                ss >> p;

                setPLeft(p);

            } else if (line.find("back") != line.npos) {

                std::stringstream ss(line);
                ss.ignore(50, ' ');

                number p;

                ss >> p;

                setPBack(p);

            }  else if (line.find("max") != line.npos) {

                std::stringstream ss(line);
                ss.ignore(50, ' ');

                int n;

                ss >> n;

                setNMax(n);

            } else if (line.find("gamma") != line.npos) {

                std::stringstream ss(line);
                ss.ignore(50, ' ');

                number p;

                ss >> p;

                setGamma(p);

            }  else if (line.find("cost") != line.npos) {

                std::stringstream ss(line);
                ss.ignore(50, ' ');

                number p;

                ss >> p;

                setStepCost(p);

            }
        }
    }
}

